#!/usr/bin/perl

##############################################################
#                                                            #
#          * * * * * *  M O Z Z Y II  * * * * * *            #
#                                                            #
#                      By Rory Austin                        #
#                http://www.mozzy.za.net/                    #
#                                                            #
#             Copyright (c) Rory Austin 2000-2002            #
#                                                            #
#     Selling or distributing this software or               #
#     modifications of this software without                 #
#     permission is expressly forbidden. Permission          #
#     to modify the script for personal use is granted.      #
#     In all cases this header and copyright                 #
#     must remain intact. All violators will be              #
#     PROSECUTED to the full extent.                         #
#                                                            #
##############################################################

BEGIN {open (STDERR, ">>error.txt");}

use strict;
use vars qw(%msg %SETUP %IN %D %R %S %N %CONTENTS %EXIST @D @FILE $conf $lang $restrict $path $agents $cachename $cachedir $file $pagetoget $template $module $return $query $msg $diemsg);

print "Content-type: text/html\n\n";

eval q{require './common.cgi';};
if($@ ne ''){	print "Error with common.cgi: $@";exit;}
&parse;

%SETUP = &LoadConf($IN{'c'});
$conf = $SETUP{'conf_name'};
$CONTENTS{'inconf'} = $IN{'c'};
%msg = &LoadLang($IN{'l'});
$CONTENTS{'inlang'} = $IN{'l'};

eval q{use LWP::Simple;};
if($@ ne ''){	&msg('nolwp', "LWP not found on server.");}

&CheckAgents;

$path = $IN{'d'};
if (($IN{'d'} eq '') and (!($ENV{'QUERY_STRING'} =~ m/[&|=]/))) {$path = $ENV{'QUERY_STRING'};}
unless ($path =~ /^$restrict/){$path = $restrict;}
$path =~ tr/+/ /;
$path =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
if (!($path =~ m~^\/~ )) {$path = "/" . $path;}
if (!($path =~ m~\/$~ )) {$path = $path . "/";}
$path =~ s~/+~/~g;
($cachename = $path) =~ s~/|\s~_~g;

if ($path ne '/') {
 if ((-e "$SETUP{'cachedir'}/$cachename")and( (-M "$SETUP{'cachedir'}/$cachename") * 24 < $SETUP{'cacheexpire'} )) {
	 open(FILE, "$SETUP{'cachedir'}/$cachename");
	 $file = join('', <FILE>);
	 close(FILE);
 }else{
	 unless ($file = get("http://www.dmoz.org$path") ) {
		&msg('noaccess', "There was an error accessing the dmoz site with: ($ENV{'QUERY_STRING'})");
	 }else{
		if (-e $SETUP{'cachedir'}) {
		 open(FILE, ">$SETUP{'cachedir'}/$cachename");
		 print FILE $file;
		 close(FILE);
		}
	 }
 }
}

$path eq '/' ? open(FILE, "$SETUP{'templatedir'}/front.html") : open(FILE, "$SETUP{'templatedir'}/main.html");
$template = join('', <FILE>);
close(FILE);

&ExecModule('autoexec', '');
$template =~ s~\[module\s([^\]]+?)\s([^\]]+?)\]~&ExecModule($1, $2)~egi;
$template =~ s~\[module\s([^\s]+?)\]~&ExecModule($1, '')~egi;
foreach (keys %CONTENTS) {  $template =~ s/\[$_\]/$CONTENTS{$_}/gi;}
$template =~ s~\[ifexist\s+(.+?)\](.*?)\[/ifexist\]~&Exist($1, $2)~sige;
$template =~ s~\[ifnotexist\s+(.+?)\](.*?)\[/ifnotexist\]~&NotExist($1, $2)~sige;
&LogRequest;
print $template;


sub DoFrontPage {
 open(FILE, "$SETUP{'templatedir'}/front.html");
 my @FILE = <FILE>;
 close(FILE);
 $template = join('', @FILE);
 $template =~ s/\[where\]/Top/g;
}

sub LogRequest {
 if ($SETUP{'logfile'} ne '')  {
	my ($day,$month,$date,$time,$year) = split(/\s+/,gmtime(time),5);
	 if ($date < 10) { $date = "0$date" };
	my $uri = "MOZZY?$ENV{'QUERY_STRING'}";
	 if ($ENV{'HTTP_REFERER'} eq "") { $ENV{'HTTP_REFERER'} = "-" };
	 open (LOG, ">>$SETUP{'logfile'}");
	 print LOG "$ENV{'REMOTE_HOST'} - - [$date/$month/$year:$time +0000] \"GET $uri HTTP/1.1\" 200 - \"$ENV{'HTTP_REFERER'}\" \"$ENV{'HTTP_USER_AGENT'}\"\n";
	 close (LOG);
	}
 }

sub CheckAgents {
 open(FILE, "agents.txt");
 @FILE = <FILE>;
 close(FILE);
 chomp @FILE;
 $agents = join('|', @FILE);
 $agents =~ s~^\|~~;
 $agents =~ s~\|$~~;
 if ($ENV{'HTTP_USER_AGENT'} =~ m/($agents)/i)
 {&msg('leachers','Disabled User Agent dissallowed.');}
}
